'**************************************
'     I2C LCD test Display test 
'	AQM0802A AKIDUKI LCD and Strawberry linux SB1602B
'     (I2C LCD 8 x 2 lines)
'	 for PICAXE 08M2
'**************************************
'	author air_variable
'	http://airvariable.asablo.jp/blog/
'	version 0.6
'	May,24th,2015
'	PICAXE Programming Editor v6.0.8.0
'	This source code is free software
'	Notice:This code is test version.
'**************************************
'	Information of Connection
'		pin1 VCC
'		pin2 serial in
'		pin3 n.c
'		pin4 n.c
'	----
'		pin8 GND
'		pin7 serial out
'		pin6 SCL(Must be 10kohm pull up)
'		pin5 SDA(Must be 10kohm pull up)
'**************************************

#PICAXE 08M2

'aki mode
'I2C initialize
hi2csetup i2cmaster,$A0, i2cfast, i2cbyte 'AKIDUKI LCD
hi2cout 0,($01)	'Function set
pause 50		'Wait
hi2cout 0,($38)	'Function set
pause 50		'Wait
hi2cout 0,($0f)	'Function set
pause 50		'Wait
hi2cout 0,($06)	'Function set
pause 300		'Wait
hi2cout 0,($80)	'Set DDR Address

hi2cout 0,($38)	'Function set
hi2cout 0,($0C)	'Display ON/OFF control
hi2cout 0,($01)	'Follower control
pause 300		'Wait
hi2cout 0,($80)	'Set DDR Address
'Displaying Hello world

hi2cout $80,("H")
hi2cout $80,("e")
hi2cout $80,("l")
hi2cout $80,("l")
hi2cout $80,("o")


'Strawberry linux mode
hi2csetup i2cmaster,$7C, i2cfast, i2cbyte 'Strawberry linux I2C LCD SB1602B
pause 50		'Wait
hi2cout 0,($38)	'Function set
hi2cout 0,($39)	'Function set
hi2cout 0,($14)	'Internal OSC frequency
hi2cout 0,($70)	'Contrast set
hi2cout 0,($56)	'Power ICON contrast control
hi2cout 0,($6C)	'Follower control
pause 300		'Wait
hi2cout 0,($38)	'Function set
hi2cout 0,($0C)	'Display ON/OFF control
hi2cout 0,($01)	'Follower control
pause 2		'Wait
hi2cout 0,($80)	'Set DDR Address

'Displaying Hello world

hi2cout $40,("H")
hi2cout $40,("e")
hi2cout $40,("l")
hi2cout $40,("l")
hi2cout $40,("o")



hi2csetup i2cmaster,$A0, i2cfast, i2cbyte 'AKIDUKI LCD
hi2cout 0,($C0)	'Set DDR Address goto 2 lines
hi2csetup i2cmaster,$7C, i2cfast, i2cbyte 'Strawberry linux I2C LCD SB1602B
hi2cout 0,($C0)	'Set DDR Address goto 2 lines

main:
	for b0=0 to 255
		b1 = b0 %8 
		b1 = $C0 + b1
		
		hi2csetup i2cmaster,$A0, i2cfast, i2cbyte 'AKIDUKI LCD
		hi2cout 0,(b1)
		hi2csetup i2cmaster,$7C, i2cfast, i2cbyte 'Strawberry linux I2C LCD SB1602B
		hi2cout 0,(b1)

		hi2csetup i2cmaster,$A0, i2cfast, i2cbyte 'AKIDUKI LCD
		hi2cout $80,(b0)
		hi2csetup i2cmaster,$7C, i2cfast, i2cbyte 'Strawberry linux I2C LCD SB1602B
		hi2cout $40,(b0)
		
		hi2csetup i2cmaster,$A0, i2cfast, i2cbyte 'AKIDUKI LCD
		hi2cout 0,($85)	'Set DDR Address
		hi2csetup i2cmaster,$7C, i2cfast, i2cbyte 'Strawberry linux I2C LCD SB1602B
		hi2cout 0,($85)	'Set DDR Address

		b1 = b0/100 
		b1 = b1 + $30	
		hi2csetup i2cmaster,$A0, i2cfast, i2cbyte 'AKIDUKI LCD
		hi2cout $80,(b1)	'Display digit 100th
		hi2csetup i2cmaster,$7C, i2cfast, i2cbyte 'Strawberry linux I2C LCD SB1602B
		hi2cout $40,(b1)	'Display digit 100th

		b1 = b0/10  % 10
		b1 = b1 + $30	
		hi2csetup i2cmaster,$A0, i2cfast, i2cbyte 'AKIDUKI LCD
		hi2cout $80,(b1)	'Display digit 10th
		hi2csetup i2cmaster,$7C, i2cfast, i2cbyte 'Strawberry linux I2C LCD SB1602B
		hi2cout $40,(b1)	'Display digit 10th

		b1 = b0 % 10
		b1 = b1 + $30
		hi2csetup i2cmaster,$A0, i2cfast, i2cbyte 'AKIDUKI LCD
		hi2cout $80,(b1)	'Display digit 1st
		hi2csetup i2cmaster,$7C, i2cfast, i2cbyte 'Strawberry linux I2C LCD SB1602B
		hi2cout $40,(b1)	'Display digit 1st
		
		pause 200		'wait 0.2sec
		next 
	goto main
	
end

